;copy write 2000 by Samuel Stearley


;ti89

 ifnd ti89
ti92plus
 endc


	include	"Os.h"

 ifd ti89
	xdef		_ti89
 endc

 ifd ti92plus
	xdef		_ti92plus
 endc

	xdef		_nostub



	movem.l	a2-a4/a6/d3,-(a7)
	move.l	200,a2
	move.l	920(a2),a4			;get help message display call
	move.l	a7,a6
	move.l	$90,a0			;get trap 4
	cmp.l		#$200000,a0			;check if it points to ram or archive
	bcc		points_to_archive		;if it points to archive then it is not installed
;-----------------------------------------
;IT NEEDS TO BE UNINSTALLED
;-----------------------------------------
	pea		wrong(pc)
	cmp.l		#"keyp",2(a0)
	bne		the_end
	move.l	12(a0),$40078			;install the old int6
	move.l	8(a0),$40090			;install the old trap 4
	move.w	6(a0),-(a7)				;handle
	move.l	604(a2),a0				;get heap free call
	jsr		(a0)
	pea		uninstall_msg(pc)
	bra		the_end
;-----------------------------------------
;IT NEEDS TO BE INSTALLED
;-----------------------------------------
points_to_archive:
	lea		trap4(pc),a1
	move.l	a0,(a1)+				;write in the address of trap 4
	move.l	$78,(a1)				;write in int 6
	pea		prompt(pc)				;tells user to press on
	jsr		(a4)
	move.l	#$600018,a1				;address to store the mask
	move.w	#$0700,d0				;want priority level to be 7
	trap		#1					;set priority level
	swap		d0
wait_loop:
	btst.b	#1,2(a1)				;check if on is pressed
	bne		wait_loop
;-----------------------------------------
;NOW TO GET THE KEYBOARD PICTURE
;-----------------------------------------
 ifd ti89
	moveq		#6,d2					;counter, 7 rows to read from
 endc

 ifd ti92plus
	moveq		#9,d2
 endc
	move.w	#$FFFF-1,d1				;the mask
	lea		storage(pc),a0			;get pointer to 8 bytes to store key state
get_keys_loop:
	move.w	d1,(a1)				;put mask to memory
	move.w	#15,d0
loop:
	nop
	dbra		d0,loop
	move.b	3(a1),(a0)+				;save the key state of that row
	rol.w		#1,d1					;need to let in the next row
	dbra		d2,get_keys_loop
	swap		d0
	trap		#1					;reset the interupt
;-----------------------------------------
;NOW TO ALLOCATE THE MEMORY
;-----------------------------------------
	move.l	#(password_end-password_start),d3
	move.l	d3,-(a7)
	move.l	584(a2),a0					;heap allocate high
	jsr		(a0)
	lea		handle(pc),a1
	pea		errorMsg(pc)
	move.w	d0,(a1)					;save it
	beq		the_end
;--------------------------------------------------
;HANDLE WAS GOOD SO INSTALL THE PROTECTION TO RAM
;--------------------------------------------------
	move.w	d0,-(a7)
	move.l	600(a2),a0				;Dereference call
	jsr		(a0)
	add.l		#$40000,a0
	move.l	a0,$40090				;install it over the old trap 4
	lea		Int6-password_start(a0),a1
	move.l	a1,$40078
	lea		password_start(pc),a1
	subq.w	#1,d3					;for dbra
copy_loop:
	move.b	(a1)+,(a0)+
	dbra		d3,copy_loop
	pea		install_msg(pc)
the_end:
	jsr		(a4)					;display whatever message was last pushed
	move.l	a6,a7
	movem.l	(a7)+,a2-a4/a6/d3
	rts

;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
;THE FOLLOWING IS THE PASSWORD PROTECTION THAT IS COPIED TO ALLOCATED RAM
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
password_start:
	bra.s		After

header:		dc.b	"keyp"		;signature
handle:		dc.w	0			;save space for handle
trap4:		dc.l	0			;save space for the old trap
oldInt6:		dc.l	0

After:
	move		#$2700,sr
	movem.l	d0-d2/a0/a1,-(a7)
	lea		indicator(pc),a0
	st.b		(a0)
BadKey:
	pea		ReturnFromTrap4(pc)	;set up for rte
	move.w	#$2700,-(a7)		;set up for rte- interupt level 7 and supervisor bit
	move.l	trap4(pc),-(a7)		;put address of the real trap 4 onto the stack
	rts
;------------------------------------------------------
;NOW TO SEE THAT THE RIGHT KEYS ARE BEING HELD DOWN
;------------------------------------------------------
ReturnFromTrap4:

	lea		$600018,a1
 ifd ti89
	moveq		#6,d2					;counter, 7 rows to read from
 endc

 ifd ti92plus
	moveq		#9,d2
 endc

	move.w	#$7FFF,d1				;the mask
	lea		storage(pc),a0			;get pointer to the to store key state
GetKeysLoop2:
	rol.w		#1,d1					;let in the next row
	move.w	d1,(a1)				;put mask to memory
	move.w	#15,d0
Loop2:
	nop
	dbra		d0,Loop2
	move.b	3(a1),d0				;get the mask
	cmp.b		(a0)+,d0				;save the key state of that row
	dbne		d2,GetKeysLoop2
	bne		BadKey
	lea		indicator(pc),a0
	clr.b		(a0)
	movem.l	(a7)+,d0-d2/a0/a1
	rte

;----Now for auto int 6 replacement-----

Int6:
	move		#$2700,sr
	movem.l	d0/a0,-(a7)
	lea		$600018,a0
	move.w	(a0),-(a7)
	move.b	indicator(pc),d0
	beq		NoCheck

;---now see if 2nd right left on is held down----

	move.w	#$02FE,(a0)
	moveq		#15,d0
Loop3:
	nop
	dbra		d0,Loop3
	cmp.b		#$E5,3(a0)				;2nd+right+left+on
	beq		ReloadHardware
NoCheck:
	pea		ReloadHardware(pc)
	move.w	#$2700,-(a7)
	move.l	oldInt6(pc),-(a7)
	rts
ReloadHardware
	move.w	(a7)+,(a0)
	movem.l	(a7)+,d0/a0
	rte
 ifd ti89
storage:	ds.b		8				;needs 8 bytes to store the keyboard state
 endc

 ifd ti92plus
storage:	ds.b		10
 endc

indicator	dc.b		0

password_end:


;--------------------------------------------------------
;AND NOW THE STRINGS
;--------------------------------------------------------

uninstall_msg:	dc.b	"Password Protection Uninstalled",0
install_msg:	dc.b	"Password Protection Installed",0
prompt:		dc.b	"Hold down keys, then press ON",0
wrong:		dc.b	"Another Password program is installed",0
errorMsg		dc.b	"Not Enough Memory",0


	END		

